from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtWidgets import QFileDialog
import win32api
from win32con import VK_MEDIA_PLAY_PAUSE, KEYEVENTF_EXTENDEDKEY
import win32con
import serial
import threading
import json
import serial.tools.list_ports

# from sound import Sound
DFGT_EVT_PULLUP = 5
DFGT_EVT_PULLDOWN = 6
DFGT_EVT_PULLREMOVE = 7
DFGT_EVT_BACK = 3
DFGT_EVT_FORWARD = 4
DFGT_EVT_RIGHT = 1
DFGT_EVT_LEFT = 2
MAX_VOLUME = 0xFFFF
# win32api.keybd_event(VK_MEDIA_PLAY_PAUSE, 0, KEYEVENTF_EXTENDEDKEY, 0)
def open_app(self, app_path):
    win32api.ShellExecute(0, "open", app_path, "", "", 1)

# Define constants
WM_APPCOMMAND = 0x319
APPCOMMAND_VOLUME_MUTE = 0x80000
APPCOMMAND_VOLUME_UP = 0xA0000
APPCOMMAND_VOLUME_DOWN = 0x90000

def next_media():
    win32api.keybd_event(win32con.VK_MEDIA_NEXT_TRACK, 0, 0, 0)
    win32api.keybd_event(win32con.VK_MEDIA_NEXT_TRACK, 0, win32con.KEYEVENTF_KEYUP, 0)

def prev_media():
    win32api.keybd_event(win32con.VK_MEDIA_PREV_TRACK, 0, 0, 0)
    win32api.keybd_event(win32con.VK_MEDIA_PREV_TRACK, 0, win32con.KEYEVENTF_KEYUP, 0)

def play_pause():
    win32api.keybd_event(VK_MEDIA_PLAY_PAUSE, 0, KEYEVENTF_EXTENDEDKEY, 0)

class Ui_MainWindow(object):
    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(800, 833)
        self.centralwidget = QtWidgets.QWidget(MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        self.browse_back = QtWidgets.QPushButton(self.centralwidget)
        self.browse_back.setGeometry(QtCore.QRect(680, 80, 111, 31))
        self.browse_back.setObjectName("browse_back")
        self.textBrowser_back = QtWidgets.QTextBrowser(self.centralwidget)
        self.textBrowser_back.setGeometry(QtCore.QRect(10, 80, 671, 31))
        self.textBrowser_back.setObjectName("textBrowser_back")
        self.label = QtWidgets.QLabel(self.centralwidget)
        self.label.setGeometry(QtCore.QRect(10, 60, 251, 16))
        self.label.setObjectName("label")
        self.label_2 = QtWidgets.QLabel(self.centralwidget)
        self.label_2.setGeometry(QtCore.QRect(10, 260, 251, 16))
        self.label_2.setObjectName("label_2")
        self.textBrowser_forward = QtWidgets.QTextBrowser(self.centralwidget)
        self.textBrowser_forward.setGeometry(QtCore.QRect(10, 280, 671, 31))
        self.textBrowser_forward.setObjectName("textBrowser_forward")
        self.browse_forward = QtWidgets.QPushButton(self.centralwidget)
        self.browse_forward.setGeometry(QtCore.QRect(680, 280, 111, 31))
        self.browse_forward.setObjectName("browse_forward")
        self.treeWidget_media_forward = QtWidgets.QTreeWidget(self.centralwidget)
        self.treeWidget_media_forward.setGeometry(QtCore.QRect(10, 310, 131, 121))
        self.treeWidget_media_forward.setObjectName("treeWidget_media_forward")
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_forward)
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_forward)
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_forward)
        self.label_3 = QtWidgets.QLabel(self.centralwidget)
        self.label_3.setGeometry(QtCore.QRect(10, 440, 251, 16))
        self.label_3.setObjectName("label_3")
        self.browse_left = QtWidgets.QPushButton(self.centralwidget)
        self.browse_left.setGeometry(QtCore.QRect(680, 460, 111, 31))
        self.browse_left.setObjectName("browse_left")
        self.textBrowser_left = QtWidgets.QTextBrowser(self.centralwidget)
        self.textBrowser_left.setGeometry(QtCore.QRect(10, 460, 671, 31))
        self.textBrowser_left.setObjectName("textBrowser_left")
        self.treeWidget_media_left = QtWidgets.QTreeWidget(self.centralwidget)
        self.treeWidget_media_left.setGeometry(QtCore.QRect(10, 490, 131, 121))
        self.treeWidget_media_left.setObjectName("treeWidget_media_left")
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_left)
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_left)
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_left)
        self.label_4 = QtWidgets.QLabel(self.centralwidget)
        self.label_4.setGeometry(QtCore.QRect(10, 610, 251, 16))
        self.label_4.setObjectName("label_4")
        self.browse_right = QtWidgets.QPushButton(self.centralwidget)
        self.browse_right.setGeometry(QtCore.QRect(680, 630, 111, 31))
        self.browse_right.setObjectName("browse_right")
        self.textBrowser_rigth = QtWidgets.QTextBrowser(self.centralwidget)
        self.textBrowser_rigth.setGeometry(QtCore.QRect(10, 630, 671, 31))
        self.textBrowser_rigth.setObjectName("textBrowser_rigth")
        self.treeWidget_media_right = QtWidgets.QTreeWidget(self.centralwidget)
        self.treeWidget_media_right.setGeometry(QtCore.QRect(10, 660, 131, 121))
        self.treeWidget_media_right.setObjectName("treeWidget_media_right")
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_right)
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_right)
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_right)
        self.left_groupBox = QtWidgets.QGroupBox(self.centralwidget)
        self.left_groupBox.setGeometry(QtCore.QRect(160, 400, 251, 61))
        self.left_groupBox.setObjectName("left_groupBox")
        self.radioButton_media_left = QtWidgets.QRadioButton(self.left_groupBox)
        self.radioButton_media_left.setGeometry(QtCore.QRect(120, 30, 141, 20))
        self.radioButton_media_left.setObjectName("radioButton_media_left")
        self.radioButton_start_left = QtWidgets.QRadioButton(self.left_groupBox)
        self.radioButton_start_left.setGeometry(QtCore.QRect(20, 30, 95, 20))
        self.radioButton_start_left.setObjectName("radioButton_start_left")
        self.groupBox_rigth = QtWidgets.QGroupBox(self.centralwidget)
        self.groupBox_rigth.setGeometry(QtCore.QRect(160, 550, 231, 71))
        self.groupBox_rigth.setObjectName("groupBox_rigth")
        self.radioButton_media_right = QtWidgets.QRadioButton(self.groupBox_rigth)
        self.radioButton_media_right.setGeometry(QtCore.QRect(120, 40, 141, 20))
        self.radioButton_media_right.setObjectName("radioButton_media_right")
        self.radioButton_start_rigth = QtWidgets.QRadioButton(self.groupBox_rigth)
        self.radioButton_start_rigth.setGeometry(QtCore.QRect(10, 40, 95, 20))
        self.radioButton_start_rigth.setObjectName("radioButton_start_rigth")
        self.forward_group = QtWidgets.QGroupBox(self.centralwidget)
        self.forward_group.setGeometry(QtCore.QRect(150, 210, 241, 71))
        self.forward_group.setObjectName("forward_group")
        self.radioButton_media_forward = QtWidgets.QRadioButton(self.forward_group)
        self.radioButton_media_forward.setGeometry(QtCore.QRect(130, 40, 141, 20))
        self.radioButton_media_forward.setObjectName("radioButton_media_forward")
        self.radioButton_forward_start = QtWidgets.QRadioButton(self.forward_group)
        self.radioButton_forward_start.setGeometry(QtCore.QRect(10, 40, 95, 20))
        self.radioButton_forward_start.setObjectName("radioButton_forward_start")
        self.treeWidget_media_back = QtWidgets.QTreeWidget(self.centralwidget)
        self.treeWidget_media_back.setGeometry(QtCore.QRect(10, 110, 131, 121))
        self.treeWidget_media_back.setObjectName("treeWidget_media_back")
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_back)
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_back)
        item_0 = QtWidgets.QTreeWidgetItem(self.treeWidget_media_back)
        self.back_group = QtWidgets.QGroupBox(self.centralwidget)
        self.back_group.setGeometry(QtCore.QRect(130, 10, 241, 71))
        self.back_group.setObjectName("back_group")
        self.media_control_back = QtWidgets.QRadioButton(self.back_group)
        self.media_control_back.setGeometry(QtCore.QRect(130, 40, 141, 20))
        self.media_control_back.setObjectName("media_control_back")
        self.start_app_back = QtWidgets.QRadioButton(self.back_group)
        self.start_app_back.setGeometry(QtCore.QRect(10, 40, 95, 20))
        self.start_app_back.setObjectName("start_app_back")
        MainWindow.setCentralWidget(self.centralwidget)
        self.menubar = QtWidgets.QMenuBar(MainWindow)
        self.menubar.setGeometry(QtCore.QRect(0, 0, 800, 26))
        self.menubar.setObjectName("menubar")
        MainWindow.setMenuBar(self.menubar)
        self.statusbar = QtWidgets.QStatusBar(MainWindow)
        self.statusbar.setObjectName("statusbar")
        MainWindow.setStatusBar(self.statusbar)

        self.retranslateUi(MainWindow)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)

    def retranslateUi(self, MainWindow):
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("Gesture Control", "Gesture Control"))
        self.browse_back.setText(_translate("Gesture Control", "Browse"))
        self.label.setText(_translate("Gesture Control", "Chose what back do"))
        self.label_2.setText(_translate("Gesture Control", "Chose what forward do"))
        self.browse_forward.setText(_translate("Gesture Control", "Browse"))
        self.treeWidget_media_forward.headerItem().setText(0, _translate("Gesture Control", "Media Control"))
        __sortingEnabled = self.treeWidget_media_forward.isSortingEnabled()
        self.treeWidget_media_forward.setSortingEnabled(False)
        self.treeWidget_media_forward.topLevelItem(0).setText(0, _translate("Gesture Control", "Play/Pause"))
        self.treeWidget_media_forward.topLevelItem(1).setText(0, _translate("Gesture Control", "Next Media"))
        self.treeWidget_media_forward.topLevelItem(2).setText(0, _translate("Gesture Control", "Prev Media"))
        self.treeWidget_media_forward.setSortingEnabled(__sortingEnabled)
        self.label_3.setText(_translate("Gesture Control", "Chose what left do"))
        self.browse_left.setText(_translate("Gesture Control", "Browse"))
        self.treeWidget_media_left.headerItem().setText(0, _translate("Gesture Control", "Media Control"))
        __sortingEnabled = self.treeWidget_media_left.isSortingEnabled()
        self.treeWidget_media_left.setSortingEnabled(False)
        self.treeWidget_media_left.topLevelItem(0).setText(0, _translate("Gesture Control", "Play/Pause"))
        self.treeWidget_media_left.topLevelItem(1).setText(0, _translate("Gesture Control", "Next Media"))
        self.treeWidget_media_left.topLevelItem(2).setText(0, _translate("Gesture Control", "Prev Media"))
        self.treeWidget_media_left.setSortingEnabled(__sortingEnabled)
        self.label_4.setText(_translate("Gesture Control", "Chose what rigth do"))
        self.browse_right.setText(_translate("Gesture Control", "Browse"))
        self.treeWidget_media_right.headerItem().setText(0, _translate("Gesture Control", "Media Control"))
        __sortingEnabled = self.treeWidget_media_right.isSortingEnabled()
        self.treeWidget_media_right.setSortingEnabled(False)
        self.treeWidget_media_right.topLevelItem(0).setText(0, _translate("Gesture Control", "Play/Pause"))
        self.treeWidget_media_right.topLevelItem(1).setText(0, _translate("Gesture Control", "Next Media"))
        self.treeWidget_media_right.topLevelItem(2).setText(0, _translate("Gesture Control", "Prev Media"))
        self.treeWidget_media_right.setSortingEnabled(__sortingEnabled)
        self.left_groupBox.setTitle(_translate("Gesture Control", "LEFT"))
        self.radioButton_media_left.setText(_translate("Gesture Control", "Media Control"))
        self.radioButton_start_left.setText(_translate("Gesture Control", "Start an App"))
        self.groupBox_rigth.setTitle(_translate("Gesture Control", "RIGHT"))
        self.radioButton_media_right.setText(_translate("Gesture Control", "Media Control"))
        self.radioButton_start_rigth.setText(_translate("Gesture Control", "Start an App"))
        self.forward_group.setTitle(_translate("Gesture Control", "FORWARD"))
        self.radioButton_media_forward.setText(_translate("Gesture Control", "Media Control"))
        self.radioButton_forward_start.setText(_translate("Gesture Control", "Start an App"))
        self.treeWidget_media_back.headerItem().setText(0, _translate("Gesture Control", "Media Control"))
        __sortingEnabled = self.treeWidget_media_back.isSortingEnabled()
        self.treeWidget_media_back.setSortingEnabled(False)
        self.treeWidget_media_back.topLevelItem(0).setText(0, _translate("Gesture Control", "Play/Pause"))
        self.treeWidget_media_back.topLevelItem(1).setText(0, _translate("Gesture Control", "Next Media"))
        self.treeWidget_media_back.topLevelItem(2).setText(0, _translate("Gesture Control", "Prev Media"))
        self.treeWidget_media_back.setSortingEnabled(__sortingEnabled)
        self.back_group.setTitle(_translate("Gesture Control", "BACK"))
        self.media_control_back.setText(_translate("Gesture Control", "Media Control"))
        self.start_app_back.setText(_translate("Gesture Control", "Start an App"))

        self.browse_back.clicked.connect(lambda: self.browse_file(self.textBrowser_back))
        self.browse_forward.clicked.connect(lambda: self.browse_file(self.textBrowser_forward))
        self.browse_left.clicked.connect(lambda: self.browse_file(self.textBrowser_left))
        self.browse_right.clicked.connect(lambda: self.browse_file(self.textBrowser_rigth))

    def browse_file(self, text):
        file_name, _ = QFileDialog.getOpenFileName(None, "Open File", "", "All Files (*)")
        text.setText(file_name)

    def readserial(self, comport, baudrate, timestamp=False):
        pause = False
        ser = serial.Serial(comport, baudrate, timeout=0.1)         # 1/timeout is the frequency at which the port is read
        last = None
        while True:

            data = ser.readline().decode().strip()
            last_volume = 0
            
            # print(last)
            if last == DFGT_EVT_PULLUP:
                win32api.keybd_event(win32con.VK_VOLUME_UP, 0)
                win32api.keybd_event(win32con.VK_VOLUME_UP, 0, win32con.KEYEVENTF_KEYUP)
            elif last == DFGT_EVT_PULLDOWN:
                win32api.keybd_event(win32con.VK_VOLUME_DOWN, 0)
                win32api.keybd_event(win32con.VK_VOLUME_DOWN, 0, win32con.KEYEVENTF_KEYUP)

            if data and timestamp:
                if not data.isnumeric():
                    continue
                if int(data) == DFGT_EVT_PULLUP:
                    last = DFGT_EVT_PULLUP
                elif int(data) == DFGT_EVT_PULLDOWN:
                    last = DFGT_EVT_PULLDOWN
                elif int(data) == DFGT_EVT_PULLREMOVE:
                    last = DFGT_EVT_PULLREMOVE
                elif int(data) == DFGT_EVT_FORWARD:
                    if self.radioButton_forward_start.isChecked():
                        open_app(True, self.textBrowser_forward.toPlainText())
                    if self.radioButton_media_forward.isChecked():
                        items = self.treeWidget_media_forward.selectedItems()
                        if items[0].text(0) == "Play/Pause":
                            play_pause()
                        elif items[0].text(0) == "Next Media":
                            next_media()
                        elif items[0].text(0) == "Prev Media":
                            prev_media()
                elif int(data) == DFGT_EVT_LEFT:
                    if self.radioButton_start_left.isChecked():
                        open_app(True, self.textBrowser_left.toPlainText())
                    if self.radioButton_media_left.isChecked():
                        items = self.treeWidget_media_left.selectedItems()
                        if items[0].text(0) == "Play/Pause":
                            play_pause()
                        elif items[0].text(0) == "Next Media":
                            next_media()
                        elif items[0].text(0) == "Prev Media":
                            prev_media()
                elif int(data) == DFGT_EVT_RIGHT:
                    if self.radioButton_start_rigth.isChecked():
                        open_app(True, self.textBrowser_rigth.toPlainText())
                    if self.radioButton_media_right.isChecked():
                        items = self.treeWidget_media_right.selectedItems()
                        if items[0].text(0) == "Play/Pause":
                            play_pause()
                        elif items[0].text(0) == "Next Media":
                            next_media()
                        elif items[0].text(0) == "Prev Media":
                            prev_media()
                elif int(data) == DFGT_EVT_BACK:
                    if self.start_app_back.isChecked():
                        open_app(True, self.textBrowser_back.toPlainText())
                    if self.media_control_back.isChecked():
                        items = self.treeWidget_media_back.selectedItems()
                        if items[0].text(0) == "Play/Pause":
                            play_pause()
                        elif items[0].text(0) == "Next Media":
                            next_media()
                        elif items[0].text(0) == "Prev Media":
                            prev_media()
            elif data:
                pass

    def init_from_file(self):
        f = open('data.json')
        data = json.load(f)
        back = data["back"]
        if back["type"] == "app":
            self.start_app_back.setChecked(True)
            self.textBrowser_back.setText(back["path"])
        elif back["type"] == "media":
            self.media_control_back.setChecked(True)
            if back["path"] == "play_pause":
                self.treeWidget_media_back.topLevelItem(0).setSelected(True)
            if back["path"] == "prev":
                self.treeWidget_media_back.topLevelItem(2).setSelected(True)
            if back["path"] == "next":
                self.treeWidget_media_back.topLevelItem(1).setSelected(True)

        forward = data["forward"]
        if forward["type"] == "app":
            self.radioButton_forward_start.setChecked(True)
            self.textBrowser_back.setText(back["path"])
        elif forward["type"] == "media":
            self.radioButton_media_forward.setChecked(True)
            if forward["path"] == "play_pause":
                self.treeWidget_media_forward.topLevelItem(0).setSelected(True)
            if forward["path"] == "prev":
                self.treeWidget_media_forward.topLevelItem(2).setSelected(True)
            if forward["path"] == "next":
                self.treeWidget_media_forward.topLevelItem(1).setSelected(True)

        right = data["right"]
        if right["type"] == "app":
            self.radioButton_start_rigth.setChecked(True)
            self.textBrowser_back.setText(back["path"])
        elif right["type"] == "media":
            self.radioButton_media_right.setChecked(True)
            if right["path"] == "play_pause":
                self.treeWidget_media_right.topLevelItem(0).setSelected(True)
            if right["path"] == "prev":
                self.treeWidget_media_right.topLevelItem(2).setSelected(True)
            if right["path"] == "next":
                self.treeWidget_media_right.topLevelItem(1).setSelected(True)

        left = data["left"]
        if left["type"] == "app":
            self.radioButton_start_left.setChecked(True)
            self.textBrowser_back.setText(back["path"])
        elif left["type"] == "media":
            self.radioButton_media_left.setChecked(True)
            if left["path"] == "play_pause":
                self.treeWidget_media_left.topLevelItem(0).setSelected(True)
            if left["path"] == "prev":
                self.treeWidget_media_left.topLevelItem(2).setSelected(True)
            if left["path"] == "next":
                self.treeWidget_media_left.topLevelItem(1).setSelected(True)

if __name__ == "__main__":
    import sys
    app = QtWidgets.QApplication(sys.argv)
    MainWindow = QtWidgets.QMainWindow()
    ui = Ui_MainWindow()
    ui.setupUi(MainWindow)
    ui.init_from_file()
    MainWindow.show()
    MainWindow.setFixedSize(MainWindow.size())
    arduino_ports = [
        p.device
        for p in serial.tools.list_ports.comports()
            if 'Arduino' in p.description  # may need tweaking to match new arduinos
    ]
    if not arduino_ports:
        raise IOError("No Arduino found")
    if len(arduino_ports) > 1:
        print("Using first arduino")

    thread = threading.Thread(target=ui.readserial, args=(arduino_ports[0], 115200, True), daemon=True)
    thread.start()
    sys.exit(app.exec_())
